#ifndef AG_STRING_H
#define AG_STRING_H

/*
 * The AGCLIB1 Class Library, Version 1.0
 * Copyright (c) Parsifal Software, 2001. All Rights Reserved.
 * http://www.parsifalsoft.com
*/

#include "agbstr.h"

class AgString : public AgCopyControl<AgStringBase> {
  friend int agABTHash(const AgString &, int);
  typedef AgCopyControl<AgStringBase> Base;
public:
  AgString() : Base(new AgStringBase){}
  AgString(int n) : Base(new AgStringBase(n)) {}
  AgString(const char *s) : Base(new AgStringBase(s)) {}
  AgString(const AgString &s) : Base(s) {}

  AgString &append(int c) {kernel()->append(c); return *this;}
  AgString &append(const char *s) {kernel()->append(s); return *this;}
  AgString &append(const char *s, int n) {kernel()->append(s, n); return *this;}

  int size() const {return kernel()->size();}
  AgString &reset() {kernel()->reset(); return *this;}

  AgString &operator = (const AgString &s) {return (AgString &) Base::operator = (s);}

  operator const char *() const {return kernel()-> operator const char *();}

  char &operator [] (int x) {return kernel()->operator[] (x);}
  const char &operator [] (int x) const {return kernel()->operator[] (x);}

  int operator <  (const char *s) const {return *kernel() < s;}
  int operator <= (const char *s) const {return *kernel() <= s;}
  int operator >  (const char *s) const {return *kernel() > s;}
  int operator >= (const char *s) const {return *kernel() >= s;}
  int operator == (const char *s) const {return *kernel() == s;}
  int operator != (const char *s) const {return *kernel() != s;}
  int operator == (const AgString &s) const {return *kernel() == *s.kernel();}
  int operator != (const AgString &s) const {return *kernel() != *s.kernel();}
};

inline int agABTHash(const AgString &s, int hashcode = 0) {
  return agABTHash(*s.kernel(), hashcode);
}

#endif
